diff --git a/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java
index 1252820ff..0aa619ea1 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java
@@ -46,7 +46,6 @@ public class TrommelGenerator {
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.AMMO_PEBBLE), 1, 4), 15)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_IRON), 1, 2), 5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DYE,1, DyeColor.BLUE.itemMeta), 2, 6), 5)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.GUNPOWDER), 1), 5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.QUARTZ), 1), 0.5)
             .create("gravel");
 
@@ -68,7 +67,6 @@ public class TrommelGenerator {
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.AMMO_PEBBLE), 1, 3), 15)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.BONE), 1, 2), 10)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.FLINT), 1, 2), 5)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.GUNPOWDER), 1), 5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.OLIVINE), 1), 5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1), 0.5)
             .create("sand");
@@ -80,8 +78,19 @@ public class TrommelGenerator {
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1), 2)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_IRON), 1), 1)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DUST_GLOWSTONE), 1, 6), 5)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.QUARTZ), 1, 3), 5)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.RUBYGLASS_CRYSTAL_CRACKED), 1, 3), 5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.NETHERCOAL), 1), 2)
             .create("soul_sand");
+
+        RecipeBuilder.Trommel(RecipesGenerator.CORE_NAMESPACE)
+                .setInput(Blocks.BRIMSAND)
+                .addEntry(new WeightedRandomLootObject(new ItemStack(Items.GUNPOWDER), 1, 2), 25)
+                .addEntry(new WeightedRandomLootObject(new ItemStack(Items.BONE), 1, 2), 10)
+                .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DUST_GLOWSTONE), 1, 4), 5)
+                .addEntry(new WeightedRandomLootObject(new ItemStack(Items.FLINT), 1, 2), 5)
+                .addEntry(new WeightedRandomLootObject(new ItemStack(Items.OLIVINE), 1), 5)
+                .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1), 0.5)
+                .create("brimsand");
+
     }
 }
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index a069def6b..85daba5cd 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -154,7 +154,7 @@ class WorkbenchGenerator {
                 "#R#")
             .addInput('#', Blocks.COBBLE_NETHERRACK)
             .addInput('S', Blocks.SOULSAND)
-            .addInput('N', Items.NETHERCOAL)
+            .addInput('N', Items.RUBYGLASS_CRYSTAL_PURE)
             .addInput('R', Items.DUST_REDSTONE)
             .create("activator", Blocks.ACTIVATOR_COBBLE_NETHERRACK.getDefaultStack());
 
@@ -1296,9 +1296,42 @@ class WorkbenchGenerator {
             )
             .addInput('#', Blocks.COBBLE_NETHERRACK)
             .addInput('Q', Items.QUARTZ)
-            .addInput('R', Items.DUST_REDSTONE)
+            .addInput('R', Items.RUBYGLASS_CRYSTAL_PURE)
             .addInput('S', Blocks.SOULSAND)
             .create("matcher", new ItemStack(Blocks.MATCHER, 1));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                        "XX",
+                        "XX")
+                .addInput('X', Items.RUBYGLASS_CRYSTAL_CRACKED)
+                .create("rubyglass", new ItemStack(Blocks.RUBYGLASS, 1));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                        "XX",
+                        "XX")
+                .addInput('X', Items.RUBYGLASS_CRYSTAL_PURE)
+                .create("rubyglass_pure", new ItemStack(Blocks.RUBYGLASS_PURE, 1));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                        "XOX",
+                        "OOO",
+                        "XOX")
+                .addInput('O', Items.RUBYGLASS_CRYSTAL_PURE)
+                .addInput('X', Blocks.COBBLE_NETHERRACK)
+                .create("rubyglass_circuit", new ItemStack(Blocks.RUBYGLASS_CIRCUIT, 1));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                        "###",
+                        "#RB",
+                        "###")
+                .addInput('#', Blocks.COBBLE_NETHERRACK)
+                .addInput('R', Items.RUBYGLASS_CRYSTAL_PURE)
+                .addInput('B', Items.BONE)
+                .create("motion_sensor", Blocks.MOTION_SENSOR_IDLE.getDefaultStack());
     }
 
     private static void generateScrapRecipes() {
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
index f31b26326..610a57353 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
@@ -28,6 +28,7 @@ public class BTAChunkProvider implements ChunkProvider {
             Global.accessor = new DummyMinecraft();
             Blocks.init();
             Items.init();
+            Dimension.init();
             new Registries();
             Biomes.init();
             WorldTypes.init();
@@ -41,9 +42,7 @@ public class BTAChunkProvider implements ChunkProvider {
 
 
     public BTAChunkProvider(long seed) {
-//        this.biomeProvider = new BiomeProviderOverworld(seed, WorldTypes.OVERWORLD_EXTENDED);
-        // TODO: Fix
-        throw new IllegalArgumentException("This is currently broken!");
+          this.biomeProvider = WorldTypes.NETHER_DEFAULT.createBiomeProvider(new DummyWorld(Dimension.NETHER));
     }
 
     public BTAChunkProvider(File worldFolder, LevelData data) {
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/DummyWorld.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/DummyWorld.java
index 0d485d500..53e7c5216 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/DummyWorld.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/DummyWorld.java
@@ -2,7 +2,6 @@ package org.useless.seedviewer.bta;
 
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.LevelStorageDummy;
@@ -10,8 +9,8 @@ import net.minecraft.core.world.settings.WorldConfiguration;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.useless.seedviewer.bta.worldloader.ChunkLoader;
+import org.useless.seedviewer.bta.worldloader.ChunkLoaderEmpty;
 
-import java.lang.reflect.Field;
 import java.util.Objects;
 
 public class DummyWorld extends World {
@@ -28,6 +27,6 @@ public class DummyWorld extends World {
 
     @Override
     protected @NotNull ChunkProvider createChunkProvider(final @NotNull LevelStorage levelStorage) {
-        return Objects.requireNonNull(CHUNK_LOADER);
+        return Objects.requireNonNullElseGet(CHUNK_LOADER, () -> new ChunkLoaderEmpty(this));
     }
 }
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoaderEmpty.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoaderEmpty.java
new file mode 100644
index 000000000..235dce36b
--- /dev/null
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoaderEmpty.java
@@ -0,0 +1,84 @@
+package org.useless.seedviewer.bta.worldloader;
+
+import net.minecraft.core.world.ProgressListener;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.chunk.DisplayChunk;
+import net.minecraft.core.world.chunk.EmptyChunk;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
+import net.minecraft.core.world.chunk.reader.*;
+import net.minecraft.core.world.pos.ChunkPosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+
+public class ChunkLoaderEmpty implements ChunkProvider {
+    public final @NotNull Chunk blankChunk;
+    public final @NotNull Chunk displayChunk;
+
+    public ChunkLoaderEmpty(World world) {
+        this.blankChunk = new EmptyChunk(world, 0, 0);
+        this.displayChunk = new DisplayChunk(world, 0, 0);
+    }
+
+    @Override
+    public boolean isChunkLoaded(@NotNull ChunkPosc chunkPos) {
+        return true;
+    }
+
+    @Override
+    public @NotNull Chunk provideChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
+        if (chunkPos.x() == 0 && chunkPos.z() == 0) {
+            return this.displayChunk;
+        }
+        return this.blankChunk;
+    }
+
+    @Override
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
+        if (chunkPos.x() == 0 && chunkPos.z() == 0) {
+            return this.displayChunk;
+        }
+        return this.blankChunk;
+    }
+
+    @Override
+    public void regenerateChunk(@NotNull ChunkPosc chunkPos) {
+
+    }
+
+    @Override
+    public void populate(@NotNull ChunkPosc chunkPos) {
+
+    }
+
+    @Override
+    public boolean saveChunks(boolean saveImmediately, @Nullable ProgressListener progressListener) {
+        return false;
+    }
+
+    @Override
+    public boolean tick() {
+        return false;
+    }
+
+    @Override
+    public boolean canSave() {
+        return false;
+    }
+
+    @Override
+    public @NotNull String getInfoString() {
+        return "";
+    }
+
+    @Override
+    public void unloadAllChunks() {
+
+    }
+
+    @Override
+    public void setCurrentChunkOver(@NotNull ChunkPosc chunkPos) {
+
+    }
+}
